<!DOCTYPE html>
<html lang="en">
<head>
  <title>67.S10</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Voucher</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="voucher-code">Mã Voucher</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="discount">Phần trăm giảm giá</label>
		</div>
		<div class="col-sm-9">
		  <input type="number" id="input-discount" name="discount" placeholder="Discount" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Ghi chú</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="createDate">Ngày Tạo</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="updateDate">Ngày sửa</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
		</div>
	  </div>
	  <div class="row pull-right">
		<div class="col-sm-12 row">
			<div class="col-sm-6 text-center">
				<button id="save_data" class="btn btn-info">Save Data</button>
			</div>
			<div class="col-sm-6 text-center">
				<button id="add-new" class="btn btn-success">Thêm Mới</button>
			</div>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="user-table">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã giảm giá</th>
        <th>Phần trăm giảm giá</th>
        <th>Ghi Chú</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
        <th>Action</th>
      </tr>
  </table>

   <!-- Modal -->
   <div class="modal fade" id="myModal-update" role="dialog">
    <div class="modal-dialog">
    
      <!-- Modal content-->
      <div class="modal-content">
        <div class="modal-header">
			<h4 class="modal-title">Cập nhập mã voucher</h4>
          	<button type="button" class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
			<div class="jumbotron container">
				<div class="row form-group">
				  <div class="col-sm-3">
					<label for="id">ID</label>
				  </div>
				  <div class="col-sm-9">
					<input type="text" id="input-ID-modal" name="id" placeholder="id" class="form-control">
				  </div>
				</div>
				<div class="row form-group">
				  <div class="col-sm-3">
					<label for="voucher-code">Mã Voucher</label>
				  </div>
				  <div class="col-sm-9">
					<input type="text" id="input-voucher-code-modal" name="vouchercodes" placeholder="Voucher code"
					  class="form-control">
				  </div>
				</div>
				<div class="row form-group">
				  <div class="col-sm-3">
					<label for="discount">Phần trăm giảm giá</label>
				  </div>
				  <div class="col-sm-9">
					<input type="number" id="input-discount-modal" name="discount" placeholder="Discount" class="form-control">
				  </div>
				</div>
				<div class="row form-group">
				  <div class="col-sm-3">
					<label for="note">Ghi chú</label>
				  </div>
				  <div class="col-sm-9">
					<input type="text" id="input-note-modal" name="note" placeholder="Note" class="form-control">
				  </div>
				</div>
				<div class="row form-group">
				  <div class="col-sm-3">
					<label for="createDate">Ngày Tạo</label>
				  </div>
				  <div class="col-sm-9">
					<input type="date" id="input-createDate-modal" name="createDate" placeholder="Create Date" class="form-control" disabled>
				  </div>
				</div>
				<div class="row form-group">
				  <div class="col-sm-3">
					<label for="updateDate">Ngày sửa</label>
				  </div>
				  <div class="col-sm-9">
					<input type="date" id="input-updateDate-modal" name="updateDate" placeholder="Update Date" class="form-control" disabled>
				  </div>
				</div>
				<div class="row pull-right">
				  <div class="col-sm-12 text-center">
					<button id="update_voucher" class="btn btn-info">update</button>
				  </div>
				</div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
        </div>
      </div>
      
    </div>
  </div>
</div>
<script>
	$(document).ready(function(){
		onPageloading();

		//Vùng 1: định nghĩa global variable (biến toàn cục)
		var idVoucher = null;
		var ModalUpdateData = {
			maVoucher : "",
			phanTramGiamGia: "",
			ghiChu: "",
		}

		var gObjectVoucher = {
			maVoucher : "",
			phanTramGiamGia: "",
			ghiChu: "",
		}

		/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
		function onPageloading(){
			var table = $("#user-table").DataTable({
			"columns": [
				{"data":"id"},
				{"data":"maVoucher"},
				{"data":"phanTramGiamGia"},
				{"data":"ghiChu"},
				{"data":"ngayTao"},
				{"data":"ngayCapNhat"},
				{"data":"action"},
			],
			"columnDefs": [
				{ 
                "targets": 6 , 
                "className": 'text-center',
                "defaultContent":
                  `
                 
                  <button type="button" class="btn btn-link btn-update" id="btn-update"><i class="fas fa-edit"></i></button>
				  <button type="button" class="btn btn-link btn-delete" id="btn-delete"><i class="fas fa-trash-alt"></i></button>
                  `
              	}, 
			]
		})
		$.ajax({
			url: "http://localhost:8080/api/vouchers",
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				table.clear();
				table.rows.add(res);
				table.draw();
			},
			error: function(err){
				console.log(err.response);
			}
		})
		}
		// sự kiện update click
		$("#user-table").on("click", ".btn-update" , function(){
			updateClick(this);
		});
		// sự kiện xoa click
		$("#user-table").on("click", ".btn-delete" , function(){
			deleteClick(this);
		});

		$("#update_voucher").on("click", function(){
			updateVoucherClick();
		});

		$("#add-new").on("click", function(){
			addNewVoucherClick();
		});
	
		// $("#user-table tbody").on("click","tr" , onRowClick);
		$("#user-table tbody").on("click","tr" , function(){
			onRowClick(this);
		});

		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
		// sự kiện thêm mới
		function addNewVoucherClick(){
			// B1 Thu Thap Du Lieu
			readDataAddNewForm(gObjectVoucher);
			// B2 Validate
			var vCheck = validateDataForm(gObjectVoucher);
			if(vCheck){
				callApiAddNewVoucher();
			}
			
		}

		// sự kiện update click
		function updateClick(paramElement){
			"use strict"
				$("#input-voucher-code-modal").val("");
				$("#input-discount-modal").val("");
				$("#input-note-modal").val("");
				$("#input-createDate-modal").val("");
				$("#input-updateDate-modal").val("");
			var vRowClick = $(paramElement).closest("tr"); // xác định tr chứa nút bấm được click
			var vTable = $("#user-table").DataTable(); // tạo biến truy xuất đến DataTbale
			var vDataRow = vTable.row(vRowClick).data(); // lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
				$("#myModal-update").modal("show");
				$("#input-ID-modal").val(vDataRow.id);
				$("#input-voucher-code-modal").val(vDataRow.maVoucher);
				$("#input-discount-modal").val(vDataRow.phanTramGiamGia);
				$("#input-note-modal").val(vDataRow.ghiChu);
				$("#input-createDate-modal").val(vDataRow.ngayTao.split("-").reverse().join("-"));
				if(vDataRow.ngayCapNhat != null){
					$("#input-updateDate-modal").val(vDataRow.ngayCapNhat.split("-").reverse().join("-"));
				}
				idVoucher = vDataRow.id;
		}
		// Sự Kiện Xóa Voucher
		function deleteClick(paramElement){
			"use strict"
			var vRowClick = $(paramElement).closest("tr"); // xác định tr chứa nút bấm được click
			var vTable = $("#user-table").DataTable(); // tạo biến truy xuất đến DataTbale
			var vDataRow = vTable.row(vRowClick).data(); // lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
			idVoucher = vDataRow.id;
			;
			if (confirm("Bạn chắc chắn muốn xóa không") == true) {
				$.ajax({
				url: "http://localhost:8080/api/vouchers/" + idVoucher,
				type: 'DELETE',
				success: function(result) {
					alert("Bạn Đã Xóa Thành Công")
						location.reload();
					}
				});
						} else {
						text = "You canceled!";
						}

			
							
		}
		
		// updateVoucher click
		function updateVoucherClick(){
			// B1 Thu Thap Du Lieu
			readDataModalForm(ModalUpdateData);
			// B2 Validate
			var vCheck = validateDataUpdateModalForm(ModalUpdateData);
			if(vCheck){
				callApiUpdateVoucher();
			}
			
		}

		function onRowClick(e){
			var vRowClick = $(e).closest("tr"); // xác định tr chứa nút bấm được click
			var vTable = $("#user-table").DataTable(); // tạo biến truy xuất đến DataTbale
			var vDataRow = vTable.row(vRowClick).data(); // lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
			callVoucherById(vDataRow.id);
			// console.log($(e.target).closest("tr").find("td:eq(0)").text())
		}
			
		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
		function callVoucherById(paramIDrow){
			"use strict";
			$.ajax({
			url: "http://localhost:8080/api/vouchers/" + paramIDrow,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				$("#input-voucher-code").val(res.maVoucher);
				$("#input-discount").val(res.phanTramGiamGia);
				$("#input-note").val(res.ghiChu);
				$("#input-createDate").val(res.ngayTao.split("-").reverse().join("-"));
				if(res.ngayCapNhat != null){
					$("#input-updateDate").val(res.ngayCapNhat.split("-").reverse().join("-"));
				}
				
			},
			error: function(err){
				console.log(err.response);
			}
		  })
		}

		// thu thap du lieu update voucher
		function readDataModalForm(data){
			data.maVoucher = $("#input-voucher-code-modal").val().trim();
			data.phanTramGiamGia = $("#input-discount-modal").val().trim();
			data.ghiChu = $("#input-note-modal").val().trim();
		}
		// Validate du lieu
		function validateDataUpdateModalForm(data){
			if(data.maVoucher == ""){
				alert("Chưa nhập mã voucher")
				return false;
			};
			if(data.phanTramGiamGia == ""){
				alert("Chưa nhập phanTramGiamGia")
				return false;
			}

			return true ;

		}
		
		//call api update voucher
		function callApiUpdateVoucher(){
			console.log(ModalUpdateData);
			
			"use strict";
			$.ajax({
			url: "http://localhost:8080/api/vouchers/" + idVoucher,
			type: "PUT",
			data: JSON.stringify(ModalUpdateData),
			contentType: 'application/json',
			success: function(res){
				alert("Cập nhập voucher thành công")
				console.log(res);
				$("#myModal-update").modal("hide");
				location.reload();
			},
			error: function(err){
				console.log(err.response);
				alert("that bai")
			}
		  })
		}

		// thu thap du lieu update voucher
		function readDataAddNewForm(data){
			data.maVoucher = $("#input-voucher-code").val().trim();
			data.phanTramGiamGia = $("#input-discount").val().trim();
			data.ghiChu = $("#input-note").val().trim();
		}
		// Validate du lieu
		function validateDataForm(data){
			if(data.maVoucher == ""){
				alert("Chưa nhập mã voucher")
				return false;
			};
			if(data.phanTramGiamGia == ""){
				alert("Chưa nhập phanTramGiamGia")
				return false;
			}

			return true ;

		}
			
		//call api add new voucher
		function callApiAddNewVoucher(){
			console.log(gObjectVoucher);
			
			"use strict";
			$.ajax({
			url: "http://localhost:8080/api/vouchers",
			type: "POST",
			data: JSON.stringify(gObjectVoucher),
			contentType: 'application/json',
			success: function(res){
				alert("Thêm Mới voucher thành công")
				console.log(res);
				location.reload();
			},
			error: function(err){
				console.log(err.response);
				alert("that bai")
			}
		  })
		}
		

	})
</script>
</body>
</html>
